<?php
namespace Teknisa\FIS\Services;

use DateTime;
use Doctrine\ORM\EntityManager;
use Teknisa\FIS\Factories\Fis25000ParametrizacaoContribuicoesFactory;
use Teknisa\Libs\Util\DateUtil;
use Teknisa\Libs\Util\Environment;
use Teknisa\Libs\Util\NewCode;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO\Row;


class Fis27100RelacionamentodeCodigodaReceitaService{
    protected $nrorg;
    protected $operador;
    protected $currentTime;
    protected $environment;
    protected $entityManager;
    protected $dataSourceManager;
    protected $factory;
    protected $newCode;

    public function __construct( $environment, $entityManager, $dataSourceManager, Fis27100RelacionamentodeCodigodaReceitaFactory $factory, NewCode $newCode){
        $this->environment       = $environment;
        $this->entityManager     = $entityManager;
        $this->dataSourceManager = $dataSourceManager;
        $this->factory           = $factory;
        $this->newCode           = $newCode;
        $this->nrorg             = $this->environment->getNrOrg();
        $this->operador          = $this->environment->getCdOperador();
        $this->currentTime       = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
    }


    public function geraNovoCodigo($tableName, $nrorg, $interval, $colSize){
        return $this->newCode->getCodeByTableName($tableName, $nrorg, $interval, $colSize);
    }

    public function saveParticipante($row){
        try {
            if($row['__is_new']){
                if(empty($resultadoBanco->getRows())){
                    $operador = $this->environment->getCdOperador();
                    $nrorg = $this->environment->getNrorgTrab();
                    $currentTime = $this->environment->getCurrentTime()->format('d/m/Y');
                    $novoCodigoMensagem = $this->geraNovoCodigo('MENSINSCESTAST',$this->environment->getNrOrgTrab(), 1, 5);
                    $row->set('IDATIVO','S');
                    $row->set('NRORG',$nrorg);
                    $row->set('NRORGULTATU',$nrorg);
                    $row->set('DTINCLUSAO',$currentTime);
                    $row->set('DTULTATU',$currentTime);
                    $row->set('CDOPERINCLUSAO',$operador);
                    $row->set('CDOPERULTATU',$operador);
                    $row->set('NRORGINCLUSAO',$nrorg);
                    $row->set('NRMENSINSCESTAST',$novoCodigoMensagem);

                    $array[] = $row;
                    $dataSet = new DataSet('mensinscestast', $array);
                    $this->dataSourceManager->persist($dataSet);
                    $this->entityManager->flush();
                }
                else{
                    throw new \Exception('Impossível Adicionar. Registro já existe.');
                }
            }else{
                $array[] = $row;
                $dataSet = new DataSet('mensinscestast', $array);
                $this->dataSourceManager->persist($dataSet);
                $this->entityManager->flush();
            }
        }catch (\Exception $e) {
            throw $e;
        }
    }
    
    public function save($row){
        $currentTime = $this->environment->getCurrentTime()->format("d/m/Y H:i:s");
        $operador = $this->environment->getCdOperador();
        $nrorg = $this->environment->getNrorgTrab();
        
        var_dump($row);die;
        $this->Fis27100RelacionamentodeCodigodaReceitaFactory->save(array(
            "NRORG" => $this->nrorg,
            "RELACCODRECIMP" => $row['CDIMPOSTO'],
            "CDLAYOUTLMAG" => $row['CDLAYOUTLMAG'],
            "CDCFOPLMAG" => $row['CDCFOPLMAG'],
            "DSCFOPLMAG" => $row['DSCFOPLMAG'],
            "DTINCLUSAO" => $currentTime,
            "NRORGINCLUSAO" => $this->nrorg,
            "CDOPERINCLUSAO" => $this->operador
        ));
    }


}