/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_CIAFILI                                                  */
/* Tabela : CIAFILI                                                           */
/*                                                                            */
/* Criao:                                                                   */
/* 09/10/2003 Bruno Leonardo                                                  */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_CIAFILI
BEFORE INSERT OR UPDATE OR DELETE
ON CIAFILI FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUCFIL := SYSDATE;
   END IF;
   IF UPDATING THEN
      :NEW.DTULTATUCFIL := SYSDATE;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('CIAFILI', :OLD.CDFILIAL, 'CDFILIAL='||:OLD.CDFILIAL||';CDCIA='||:OLD.CDCIA||';',SYSDATE);
   END IF;
END;
/

ALTER TABLE CIAFILI MODIFY DTULTATUCFIL DEFAULT SYSDATE
/
